import sklearn.metrics
import torch

from base import Metric


class Accuracy(Metric):
    def __init__(name: str):
        super().__init__(name=name, model=None)
        self.authorized_metric = [
            "precision_score",
            "precision_score",
            "jaccard_score",
            "roc_auc_score",
            "f1_score",
            "accuracy_score",
        ]

        self.metric = self.load_metric(name)

    def load_metric(name):
        if name in self.authorized_metric:
            self.metric = eval("sklearn.metric.{name}")
        else:
            raise ValueError(f"{name} is not supported")

    def forward(self, mask, target: Tensor) -> float:
        if mask.type() == torch.bool and target.type() == torch.bool:
            return self.metric(y_pred=mask, y_true=target)
